////////////////////////////////////////////////////////////////////////
//                 Beschriftung erzeugen und Batch ausfhren
////////////////////////////////////////////////////////////////////////
// Erstellt am:     2009-12-02
// Erstellt von:    Jonny Wire
////////////////////////////////////////////////////////////////////////

using System.IO;
using System.Diagnostics;

public class PostAndPrint
{
    [DeclareAction("PostAndExecute")]
    public void PostAndExecuteVoid()
    {
        // < Allgemeine Daten: Anfang >
        // Dateinamen
        string sDestFile = @"C:\Zieldatei.xls";     // Zieldatei
        string sPost = @"Name der Beschriftung";    // Beschriftungsschema
        string sBatch = @"C:\Batchdatei.bat";

        // Projektdatei, Projektpfad, Projektname
        string sSelectedProjectData = string.Empty;     // kompletter Pfad + Projektdateinamen + Erweiterung
        string sSelectedProjectName = string.Empty;     // Projektname
        string sSelectedProjectPath = string.Empty;     // Projektpfad

        // Projektdatei komplett
        CommandLineInterpreter oCLI = new CommandLineInterpreter();
        Eplan.EplApi.ApplicationFramework.ActionCallingContext ctx = new Eplan.EplApi.ApplicationFramework.ActionCallingContext();
        ctx.AddParameter("TYPE", "PROJECT");

        bool bRet = oCLI.Execute("selectionset", ctx); // Action: Projektpfad
        if (bRet == true)
        {
            ctx.GetParameter("PROJECT", ref sSelectedProjectData);
        }

        // Projektpfad
        sSelectedProjectPath = System.IO.Path.GetDirectoryName(sSelectedProjectData);

        // Projektname
        sSelectedProjectName = System.IO.Path.GetFileNameWithoutExtension(sSelectedProjectData);

        // Bugfix 1.9.10
        oCLI.Execute("EsGenerateConnections");
        // < Allgemeine Daten: Ende >

        // Abfrage: YES/NO
        DialogResult oDialogResult = new DialogResult();
        oDialogResult = MessageBox.Show("Soll " + sDestFile + " erzeugt werden?", "PostAndExecute [" + sSelectedProjectName + "]", MessageBoxButtons.YesNo);

            if (oDialogResult == DialogResult.Yes)
            {
                // Beschriftung
                Progress progress = new Progress("SimpleProgress");
                progress.SetTitle("Beschriftung wird erzeugt...");
                progress.SetActionText(sDestFile + " wird erzeugt...");
                progress.ShowImmediately();
                progress.BeginPart(100,"");
                progress.SetAllowCancel(true);
                if(!progress.Canceled())
                {
                progress.BeginPart(100,"Labelling");
                ActionCallingContext labellingContext = new ActionCallingContext ();
                labellingContext.AddParameter("CONFIGSCHEME", sPost); // Name der Beschriftung
                labellingContext.AddParameter("DESTINATIONFILE", sDestFile); // Zieldatei
                labellingContext.AddParameter("FILTERSCHEME","");
                labellingContext.AddParameter("LANGUAGE","de_DE");
                labellingContext.AddParameter("LogMsgActionDone","true");
                labellingContext.AddParameter("SHOWOUTPUT","1");
                labellingContext.AddParameter("RECREPEAT","1");
                labellingContext.AddParameter("SORTSCHEME","");
                labellingContext.AddParameter("TASKREPEAT","1");
                new CommandLineInterpreter().Execute("label",labellingContext);
                progress.EndPart();
                }
                progress.EndPart(true);
                
                // Batch ausfhren


                ProcessStartInfo pInf = new ProcessStartInfo(sBatch); // edit: <parameter> hinzugefgt: welche du auch immer bergeben willst...
                Process proc = Process.Start(pInf);

            }

    }
}